import greenfoot.Actor;
import greenfoot.Greenfoot;
import greenfoot.GreenfootSound;
import greenfoot.World;
import java.awt.Color;
import java.util.Random;

import java.io.BufferedReader;
import java.io.FileReader;
import java.io.BufferedWriter;
import java.io.File;
import java.io.FileWriter;
import java.io.IOException;

public class Kara
  extends Actor
{
  private static enum Direction{NORTH,  SOUTH,  WEST,  EAST;}
  
  public Score score = new Score();
  public Label time = new Label("Time left: ");
  public Label wow = new Label("WOW");
  public Label startstop = new Label("GO");
  public Label[] sc = new Label[10];
  private int onfield = 0;
  public Leaf[] bones = new Leaf[500];
  
  private long sec;
  private long ti;
  private GreenfootSound sound = new GreenfootSound("EPIC.mp3");
  private boolean first = true;
  Direction d = Direction.EAST;
  
  public Kara()
  {
    changeColor("blau");
    load();
  }
  
  public void act()
  {
    if (first)
    {
      sound.playLoop();
      sec = System.currentTimeMillis();
      sec /= 1000L;
      ti = (System.currentTimeMillis() / 1000L);
      teleport();
      first = false;
    }
    if (Greenfoot.isKeyDown("w"))
    {
      switch (d)
      {
      case NORTH:
        break;
      case SOUTH: 
        turnLeft();
        turnLeft();
        break;
      case WEST: 
        turnRight();
        break;
      case EAST: 
        turnLeft();
      }
      d = Direction.NORTH;
      move();
    }
    if (Greenfoot.isKeyDown("d"))
    {
      switch (d)
      {
      case NORTH: 
        turnRight();
        break;
      case SOUTH: 
        turnLeft();
        break;
      case WEST: 
        turnRight();
        turnRight();
        break;
      }
      d = Direction.EAST;
      move();
    }
    if (Greenfoot.isKeyDown("s"))
    {
      switch (d)
      {
      case NORTH: 
        turnRight();
        turnRight();
        break;
      case SOUTH: 
        break;
      case WEST: 
        turnLeft();
        break;
      case EAST: 
        turnRight();
      }
      d = Direction.SOUTH;
      move();
    }
    if (Greenfoot.isKeyDown("a"))
    {
      switch (d)
      {
      case NORTH: 
        turnLeft();
        break;
      case SOUTH: 
        turnRight();
        break;
      case WEST: 
        break;
      case EAST: 
        turnRight();
        turnRight();
      }
      d = Direction.WEST;
      move();
    }
    if (Greenfoot.isKeyDown("m")) {
      sound.stop();
    } else if (Greenfoot.isKeyDown("1")) {
      sound.setVolume(10);
    } else if (Greenfoot.isKeyDown("2")) {
      sound.setVolume(20);
    } else if (Greenfoot.isKeyDown("3")) {
      sound.setVolume(30);
    } else if (Greenfoot.isKeyDown("4")) {
      sound.setVolume(40);
    } else if (Greenfoot.isKeyDown("5")) {
      sound.setVolume(50);
    } else if (Greenfoot.isKeyDown("6")) {
      sound.setVolume(60);
    } else if (Greenfoot.isKeyDown("7")) {
      sound.setVolume(70);
    } else if (Greenfoot.isKeyDown("8")) {
      sound.setVolume(80);
    } else if (Greenfoot.isKeyDown("9")) {
      sound.setVolume(90);
    } else if (Greenfoot.isKeyDown("0")) {
      sound.setVolume(100);
    } else if (Greenfoot.isKeyDown("n")) {
      sound.playLoop();
    }
    if (onLeaf())
    {
      Random rand = new Random();
      int randomNum = rand.nextInt(2) + 1;
      sec += randomNum;
      score.add(1);
      score.act();
      
      removeLeaf();
      if (onfield > 1) {
        score.add(-1);
      }
      onfield -= 1;
      say();
      if (rand.nextInt(1) == 1) {
        teleport();
      }
    }
    Actor actor = getOneObjectAtOffset(10, 10, Score.class);
    if ((keyHeld("w")) || (keyHeld("a")) || (keyHeld("s")) || ((keyHeld("d")) && (actor == null))) {
      move();
    }
    fivesec();
    timer();
    time.setLabel(String.valueOf(25L - (System.currentTimeMillis() / 1000L - sec) + "sec. left"));
  }
  
  public void load()
  {
    for (int i = 0; i < 500; i++) {
        bones[i] = new Leaf();
    }
    for (int j = 0; j < 10; j++)
    {
        sc[j] = new Label(" ");
    }
    score.load();
    score.act();
  }
  
  public void teleport()
  {
    Random rand = new Random();
    int randomNum = rand.nextInt(500) + 0;
    bones[randomNum].setLocation(rand.nextInt(471) + 20, rand.nextInt(161) + 20);
    onfield += 1;
  }
  
  public void say()
  {
    int rnd = Greenfoot.getRandomNumber(9);
    String[] such = { "such bone", "much delicous", "wow sparkle score", "much graphics", "me hungry", "so Hitbox", "much EPIC", "me so wow", "so background music", "much loud" };
    wow.setP(getX(), getY());
    wow.setLabel(such[rnd]);
  }
  
  public boolean keyHeld(String n)
  {
    return Greenfoot.isKeyDown(n);
  }
  
  private void fivesec()
  {
    if (System.currentTimeMillis() / 1000L - ti > 1L)
    {
      teleport();
      ti = (System.currentTimeMillis() / 1000L);
    }
  }
  
  private void timer()
  {
    if (System.currentTimeMillis() / 1000L - sec > 25L)
    {
      Color clr = Color.red;
      
      startstop.setLocation(250, 30);
      startstop.setColor(clr);
      startstop.setLabel("!END! wow such SCORE: " + String.valueOf(score.get()));
      wow.setLabel("much sad");
      highScore();
      sound.stop();
      Greenfoot.stop();
    }
  }
  
  
  public void highScore()
  {
	  BufferedReader in = null;
	  
	  int[] fscore = new int[10];
	  try { 
		  in = new BufferedReader(new FileReader("highscore.txt"));
	        
 
		  String ln = null;
		  StringBuilder enc = new StringBuilder();
		  int j = 0;
		  while ((ln = in.readLine()) != null && j < 10) { 
			  for (int i = 0; i < ln.length(); i++) {
				  enc.append(ln);
			  }
			  fscore[j] = Integer.parseInt(enc.toString());
			  //out.write(enc.toString());
			  enc.setLength(0);
			  j++;
		  }
		  try { 
			  if (in != null)in.close();
		  } catch(Exception ex) {
			  ex.printStackTrace();
		  }
		  
		  sort s = new sort();
		  fscore = s.sort(fscore);
		  
		  if (score.get() >= fscore[9])
		  {
		      fscore[9] = score.get();
		      fscore = s.sort(fscore);
		  }
		  
		  File file = new File("highscore.txt");
		  file.createNewFile();

		  FileWriter fw = new FileWriter(file.getAbsoluteFile());
		  boolean a = false; 
	      
	      for (int i = 0;  i < 10; i++)
	      {  
	          //sc[i].setLocation(300, 50 + (i * 15));
	          if (fscore[i] == score.get() && !a)
	          {
	              //sc[i].setLocation(350, (50 + (i * 15)));
	              sc[i].setLabel("You are one the " + (i + 1) + ". place: " + String.valueOf(fscore[i]));
	              a = true;
	           }else{
	               sc[i].setLabel((i + 1) + ". place: " + String.valueOf(fscore[i]));
	           }
	       }
		  
	      
		  for (int i = 0; i < 10; i++)
		  {
			  System.out.println(fscore[i]);
			  fw.write(String.valueOf(fscore[i]));
			  fw.write("\r\n");
		  }
		  
		  fw.flush();
		  fw.close();
	  } catch(Exception e) {
		  e.printStackTrace();
	  }
  }
  
  public void move()
  {
    Actor actor = getOneObjectAtOffset(10, 10, Score.class);
    if ((actor == null) || (d == Direction.NORTH) || (d == Direction.WEST)) {
      move(2);
    }
  }
  
  public void turnLeft()
  {
    setRotation(getRotation() - 90);
  }
  
  public void turnRight()
  {
    setRotation(getRotation() - 270);
  }
  
  public boolean onLeaf()
  {
    Actor actor = getOneObjectAtOffset(0, 0, Leaf.class);
    return actor != null;
  }
  
  public void removeLeaf()
  {
    Actor actor = getOneObjectAtOffset(0, 0, Leaf.class);
    if (actor != null) {
      getWorld().removeObject(actor);
    }
  }
  
  public void changeColor(String farbe)
  {
    if ((farbe.equals("blau")) || (farbe.equals("rot")) || (farbe.equals("gruen"))) {
      setImage("kara.png");
    }
  }
  
  private void move(double speed)
  {
    double angle = Math.toRadians(getRotation());
    int x = (int)Math.round(getX() + Math.cos(angle) * speed);
    x = (x + getWorld().getWidth()) % getWorld().getWidth();
    int y = (int)Math.round(getY() + Math.sin(angle) * speed);
    y = (y + getWorld().getHeight()) % getWorld().getHeight();
    setLocation(x, y);
  }
}
